/*
Lite version of SUD Mutilator
I've removed all the DecSetWrite / wobble dumping stuff, as header deobfuscation wasn't implemented...
Precompiled binary and source code are public. No license. Feel free to use and distribute this code as you want.

kHn, 02/09/2013
*/

#include <kernel.h>
#include <loadfile.h>
#include <stdio.h>
#include <string.h>
#include <debug.h>
#include <libcdvd.h>

char syscnf[] = "cdrom0:\\SYSTEM.CNF;1";
char subprog[] = "cdrom0:\\FILES\\PS289.VOB;1";
char JAP[] = "(NTSC J)";
char US[] = "(NTSC U/C)";
char PAL[] = "(PAL)";
char HDD[] = "HDD";
char _HDD[] = "- HDD";
char util[] = "Utility Disc";
char DVD[] = "DVD Player";
char ver[] = "Version";
char bbn[] = "PlayStation BB Navigator";
char dot[] = ".";
char v010[] = "0.10";
char v020[] = "0.20";
char v030[] = "0.30";
char v031[] = "0.31";
char v032[] = "0.32";
char v100[] = "1.00";
char v101[] = "1.01";
char v110[] = "1.10";
char v201[] = "2.01";
char v210[] = "2.10";
char v212[] = "2.12";
char v214[] = "2.14";
char v216[] = "2.16";
char v300[] = "3.00";
char v304[] = "3.04";
char label[] = "Label :";
static const char *executable[21] = {"PBPX-95201", "PBPX-95202", "SCPN-60101", "SCPN-60130", "SCPN-60140", "SCPN-60150", "SCPN-60160", "PBPX-95207", "PBPX-95221", "PBPX-95216", "PBPX-95211", "SCUS-97395", "PBPX-95210", "PBPX-95218", "PBPX-95208", "PBPX-95209", "PBPX-95219", "PBPX-95206", "PBPX-95221", "PBPX-95224", "PBPX-95223"};
char empty[] = "Disc drive is empty or disc is damaged.";
char invalid[] = "Not a valid PS2 disc or unrecognized utility disc.";
char invalid2[] = "Not an original disc nor your modchip is still enabled.";
char unk[] = "Unrecognized utility disc.";
char terminated[] = "Terminated !";
char needed[] = "        I need a dump of this disc.\n";
static const char *bannedid[3] = {"07 F7 F2 01 00 00 01 ", "00 00 00 00 00 00 00", "SXC"};
unsigned char discID[16];
unsigned char firm[3];
long int firmdec;

static unsigned int getStat()
{
    register unsigned int rv;
    asm volatile (
        "mfc0 %0, $12\n"
        "nop\n" : "=r"
	(rv) : );
    return rv;
}

static void setStat(unsigned int v)
{
	asm volatile (
		"mtc0 %0, $12\n"
		"nop\n"
	: : "r" (v) );
}

//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
int PrintPad()
{
	scr_printf("\t \n\n\n\n\n\n\n\n\n\n\n\n\n");

 	return 1;
}
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
int PrintSingleJump()
{
	scr_printf("\t \n");

 	return 1;
}
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
int PrintProgVer()
{
	scr_clear();
	scr_printf("\t \n\n");
	scr_printf("\t S.U.D. Mutilator  --  Public -- Lite Version (02/09/2013)\n");
	scr_printf("\t \n\n");

 	return 1;
}
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
int GetCDVDkey()
{
	cdSync(3);

	unsigned char ReadKey[] = {0x00, 0x00, 0x00, 0x96, 0x10, 0x00, 0x00 };
	cdSync(3);
	cdApplyNCmd(0x0c, ReadKey, sizeof(ReadKey), NULL, 0);

	cdSync(0);

	cdStop();
	cdSync(0);
	setStat(getStat() & (~0x18));

	discID[0] = *(volatile unsigned char*)0xBF402020 ^ *(volatile unsigned char *)0xBF402039;
	discID[1] = *(volatile unsigned char*)0xBF402021 ^ *(volatile unsigned char *)0xBF402039;
	discID[2] = *(volatile unsigned char*)0xBF402022 ^ *(volatile unsigned char *)0xBF402039;
	discID[3] = *(volatile unsigned char*)0xBF402023 ^ *(volatile unsigned char *)0xBF402039;
	discID[4] = *(volatile unsigned char*)0xBF402024 ^ *(volatile unsigned char *)0xBF402039;
	discID[5] = *(volatile unsigned char*)0xBF402025 ^ *(volatile unsigned char *)0xBF402039;
	discID[6] = *(volatile unsigned char*)0xBF402026;
	discID[7] = *(volatile unsigned char*)0xBF402027;
	discID[8] = *(volatile unsigned char*)0xBF402028;
	discID[9] = *(volatile unsigned char*)0xBF402029;
	discID[10] = *(volatile unsigned char*)0xBF40202a;
	discID[11] = *(volatile unsigned char*)0xBF40202b;
	discID[12] = *(volatile unsigned char*)0xBF40202c;
	discID[13] = *(volatile unsigned char*)0xBF40202d;
	discID[14] = *(volatile unsigned char*)0xBF40202e;
	discID[15] = *(volatile unsigned char*)0xBF40202f;

	setStat((getStat() & (~0x18)) | 0x10);

	snprintf(firm, 7, "%02X%02X%02X", discID[3], discID[2], discID[1]);
	firmdec=strtol(firm, NULL, 16);

	return 1;
}
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
void ParseSystemCNF()
{
	int fd, fdSize;
	int i;
	char *r  = NULL;
	char *thread1 = NULL;
	char *thread2 = NULL;
	char *thread3 = NULL;


	fd = fioOpen(syscnf, O_RDONLY);
	fdSize = fioLseek(fd, 0, SEEK_END);
	fioLseek(fd, 0, SEEK_SET);

	thread1 = malloc(fdSize + 1);
	fioRead(fd, thread1, fdSize);
	thread1[fdSize] = '\0';

	thread1 = strstr(thread1, "BOOT2");
	thread1 += 16;

	i = 0;
	while((thread1[i] != ';') && (thread1[i] != '\r')) i++;

	thread1[i] = '\0';
	u_char separator[1] = { 0x2D };
	thread1[4] = separator[0];
	thread1[8] = thread1[9];
	thread1[9] = thread1[10];
	thread1[10] = '\0';

	PrintProgVer();

	if (strstr(executable[0], thread1) == executable[0])	{scr_printf("\t %s %s %s %s %s\n", label, util, ver, v100, JAP); r = thread1;}
	if (strstr(executable[1], thread1) == executable[1])	{scr_printf("\t %s %s %s %s %s\n", label, util, ver, v101, JAP); r = thread1;}
	if (strstr(executable[2], thread1) == executable[2])	{scr_printf("\t %s %s %s %s PRERELEASE %s\n", label, bbn, ver, v010, JAP); r = thread1;}
	if (strstr(executable[3], thread1) == executable[3])	{scr_printf("\t %s %s %s %s %s\n", label, bbn, ver, v020, JAP); r = thread1;}
	if (strstr(executable[4], thread1) == executable[4])	{scr_printf("\t %s %s %s %s %s\n", label, bbn, ver, v030, JAP); r = thread1;}
	if (strstr(executable[5], thread1) == executable[5])	{scr_printf("\t %s %s %s %s %s\n", label, bbn, ver, v031, JAP); scr_printf("\t %s\n", needed); r = thread1;}
	if (strstr(executable[6], thread1) == executable[6])	{scr_printf("\t %s %s %s %s %s\n", label, bbn, ver, v032, JAP); r = thread1;}
	if (strstr(executable[7], thread1) == executable[7])	{scr_printf("\t %s %s %s %s %s\n", label, DVD, ver, v210, JAP); scr_printf("\t %s\n", needed); r = thread1;}
	if (strstr(executable[8], thread1) == executable[8])	{scr_printf("\t %s %s %s %s %s\n", label, DVD, ver, v212, JAP); scr_printf("\t %s\n", needed); r = thread1;}
	if (strstr(executable[9], thread1) == executable[9])	{scr_printf("\t %s %s %s %s %s %s\n", label, HDD, util, ver, v100, US); r = thread1;}
	if (strstr(executable[10], thread1) == executable[10]) 	{scr_printf("\t %s %s %s %s %s %s\n", label, util, ver, v100, _HDD, JAP); r = thread1;}
	if (strstr(executable[11], thread1) == executable[11]) 	{scr_printf("\t %s %s %s %s %s %s\n", label, HDD, util, ver, v110, US); r = thread1;}
	if (strstr(executable[12], thread1) == executable[12]) 	{scr_printf("\t %s %s %s %s %s\n", label, DVD, ver, v210, US); r = thread1;}
	if (strstr(executable[13], thread1) == executable[13]) 	{scr_printf("\t %s %s %s %s %s\n", label, DVD, ver, v212, US); r = thread1;}
	if (strstr(executable[14], thread1) == executable[14]) 	{scr_printf("\t %s %s %s %s %s\n", label, DVD, ver, v210, PAL); r = thread1;}
	if (strstr(executable[15], thread1) == executable[15]) 	{scr_printf("\t %s %s %s %s %s\n", label, DVD, ver, v210, PAL); scr_printf("\t %s\n", needed); r = thread1;}
	if (strstr(executable[16], thread1) == executable[16]) 	{scr_printf("\t %s %s %s %s %s\n", label, DVD, ver, v214, PAL); r = thread1;}
	if (strstr(executable[17], thread1) == executable[17]) 	{scr_printf("\t %s %s %s %s %s\n", label, DVD, ver, v201, JAP); scr_printf("\t %s\n", needed); r = thread1;}
	if (strstr(executable[18], thread1) == executable[18]) 	{scr_printf("\t %s %s %s %s %s\n", label, DVD, ver, v212, JAP); scr_printf("\t %s\n", needed); r = thread1;}
	if (strstr(executable[19], thread1) == executable[19]) 	{scr_printf("\t %s %s %s %s %s\n", label, DVD, ver, v216, JAP); scr_printf("\t %s\n", needed); r = thread1;}
	if (strstr(executable[20], thread1) == executable[20]) 	{scr_printf("\t %s %s %s %s %s\n", label, DVD, ver, v214, US); scr_printf("\t %s\n", needed); r = thread1;}

	if (r == NULL)	scr_printf("\t Unknown DVD Player/Utility Disc. Please send me a dump of it I BEG OF YOU.\n");

	scr_printf("\t \n");
	scr_printf("\t PID : %s\n", thread1);
	free(thread1);


	fioLseek(fd, 0, SEEK_SET);
	thread2 = malloc(fdSize + 1);
	fioRead(fd, thread2, fdSize);
	thread2[fdSize] = '\0';

	thread2 = strstr(thread2, "VER");
	thread2 += 6;

	i = 0;
	while((thread2[i] != '\n') && (thread2[i] != '\r')) i++;

	thread2[i] = '\0';

	scr_printf("\t Master Version : %s", thread2);

	free(thread2);

	fioLseek(fd, 0, SEEK_SET);
	thread3 = malloc(fdSize + 1);
	fioRead(fd, thread3, fdSize);
	fioClose(fd);
	thread3[fdSize] = '\0';

	thread3 = strstr(thread3, "VMODE");
	thread3 += 8;

	i = 0;
	while((thread3[i] != '\n') && (thread3[i] != '\r')) i++;

	thread3[i] = '\0';

	scr_printf(" (%s)\n", thread3);

	free(thread3);

}
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
int VerifyDisc()
{
	u32 cl;

	cdInit(CDVD_INIT_NOCHECK);
	if(cdStatus() == CDVD_STAT_OPEN) {
		cdTrayReq(CDVD_TRAY_CLOSE, &cl);
	}

	scr_printf("%s", dot);

	cdDiskReady(0);
	CdvdDiscType_t cdmode = cdGetDiscType();
	if(cdmode == CDVD_TYPE_NODISK) {
		PrintSingleJump();
		scr_printf("\t %s %s\n", empty, terminated);
		PrintPad();
		PrintPad();
		return -2;
	}

	scr_printf("%s", dot);

	if((cdmode != CDVD_TYPE_PS2DVD) && (cdmode != CDVD_TYPE_PS2CD)) {
		PrintSingleJump();
		scr_printf("\t %s %s\n", invalid, terminated);
		PrintPad();
		PrintPad();
		return -2;
	}

	scr_printf("%s", dot);

	if(fioOpen(subprog, O_RDONLY) < 0) {
		PrintSingleJump();
		scr_printf("\t %s %s\n", unk, terminated);
		PrintPad();
		PrintPad();
		return -1;
	}

	GetCDVDkey();

	scr_printf("%s", dot);

	return 1;
}
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
int DisplayCDVDkey()
{
	unsigned char hexDiscID[20];

	snprintf(hexDiscID, 21, "%02X %02X %02X %02X %02X %02X %02X", discID[0], discID[1], discID[2], discID[3], discID[4], discID[14], discID[15]);

	if(strstr(bannedid[1], hexDiscID) == bannedid[1])	return -4;

	scr_printf("\t \n");
	scr_printf("\t The cdvdKey is : %s\n", hexDiscID);
	printf("\n");
	printf("The cdvdKey is : %s\n", hexDiscID);

	scr_printf("\t 1st wobble is located at LBA %ld\n\n", firmdec);
	printf("\n");
	printf("1st wobble is located at LBA %ld\n", firmdec);
	if(strstr(bannedid[0], hexDiscID) == bannedid[0])	scr_printf("\t If you read my message thru PCSX2... Fission Mailed dude ;) !\n\n");

	return 1;
}
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
int GetRawDiscID()
{

	if(VerifyDisc() < 1) return 0;

	scr_printf("%s", dot);

	ParseSystemCNF();

	int ret = DisplayCDVDkey();

	if(ret < 1)	{
				scr_printf("\t \n\n");
				scr_printf("\t %s %s\n", invalid2, terminated);
				PrintPad();
				PrintPad();
				return 0;
	}

	cdStop();

	scr_printf("\t \n");
	scr_printf("\t Finished ! Thanks for using S.U.D Mutilator.\n");
	printf("\n");

	PrintPad();

	return 1;
}
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
int main(void)
{
	init_scr();

	scr_setbgcolor(0x93541C);

	PrintProgVer();

	if(SifLoadModule("rom0:ADDDRV", 0, NULL) < 0) {
		scr_printf("\t Failed to init. TERMINATED.");
		printf("Failed to init. TERMINATED.\n");
		SleepThread();
	}

	if(SifLoadModule("rom0:CDVDMAN", 0, NULL) < 0) {
		scr_printf("\t Failed to init. TERMINATED.");
		printf("Failed to init. TERMINATED.\n");
		SleepThread();
	}

	if(SifLoadModule("rom0:CDVDFSV", 0, NULL) < 0) {
		scr_printf("\t Failed to init. TERMINATED.");
		printf("Failed to init. TERMINATED.\n");
		SleepThread();
	}

	scr_printf("\t Gathering stuff and taking a poo. Please wait.");
	printf("SUD Mutilator inited. Please wait\n");

	GetRawDiscID();

	printf("Over\n");
	SleepThread();

	return 0;
}
